<?php

class GJMAA_Form {

	protected $fields;
	
	protected $html = '';
	
	protected $inner_content = '';
	
	protected $values;
	
	protected $formId;
	
	public function prepareForm()
	{
		return $this;
	}
	
	public function getFields()
	{
		return $this->fields;
	}
	
	public function setFields($fields)
	{
		$this->fields = $fields;
		return $this;
	}
	
	public function generate($withFormContainer = true)
	{
		if($withFormContainer) $this->startForm();
		$this->html .= '<table>';
		foreach($this->fields as $name => $fieldData)
		{
			$field = GJMAA::getFormField($fieldData['type']);
			if(null !== $this->getValues($name))
			{
				$fieldData['value'] = $this->getValues($name);
			}
			$field->setInfo($fieldData);
			$this->html .= '<tr><th>'.$field->toHtml().'</td></tr>';
		}
		$this->displayInnerContent();
		$this->html .= '</table>';
		if($withFormContainer) $this->endForm();
		
		return $this;
	}
	
	public function toHtml()
	{
		return $this->html;
	}
	
	public function addField($name,$fieldData){
		$this->fields[$name] = $fieldData;
	}
	
	public function removeField($name)
	{
		if(isset($this->fields[$name]))
		{
			unset($this->fields[$name]);
		}
	}
	
	public function startForm()
	{
		$this->html .= '<form id="'.$this->getFormId().'" name="'.$this->getFormName().'" action="'.$this->getAction().'" method="POST">';
	}
	
	public function endForm()
	{
		$this->html .= '</form>';
	}
	
	public function getFormName()
	{
		return strtolower(get_class($this));
	}
	
	public function getAction()
	{
		return '';
	}
	
	public function setValues($values)
	{
		$this->values = $values;
		return $this;
	}
	
	public function getValues($key = null)
	{
		return $key ? (isset($this->values[$key]) ? $this->values[$key] : null) : $this->values;
	}
	
	public function displayInnerContent(){
		$this->html .= $this->getInnerContent();
	}
	
	public function getInnerContent(){
		return $this->inner_content;
	}
	
	public function setInnerContent($content) {
		$this->inner_content = $content;
	}
	
	public function getPageName() {
		return 'gjmaa_settings';
	}
	
	public function getFormId(){
		return $this->formId;
	}
	
	public function setFormId($formId){
		$this->formId = $formId;
		return $this;
	}
}