<?php

class GJMAA_Form_Field {

	protected $type = 'text';
	
	protected $label = '';
	
	protected $input = '';
	
	protected $info;
	
	protected $excludedHelpType = ['hidden','button','submit'];
	
	public function toHtml()
	{
	    $help = !in_array($this->type,$this->excludedHelpType) && $this->getInfo('help') ? '</th><td><span class="fa fa-question help" title="'.__($this->getInfo('help'),GJMAA_TEXT_DOMAIN).'"></span><td>' : '</th><td colspan="2">';
	    return $this->getLabel() . $help . $this->getInput();
	}
	
	public function getLabel()
	{
		return '<label for="'.$this->getInfo('name').'">' . __($this->getInfo('label'),GJMAA_TEXT_DOMAIN) . '</label>';
	}
	
	public function getInput()
	{
	    $id = $this->getInfo('id') ? ' id="'.$this->getInfo('id').'"' : '';
	    $type = ' type="' . $this->getInfo('type') . '"';
	    $name = ' name="' . $this->getInfo('name') . '"';
	    $value = ' value="' . $this->getInfo('value') . '"';
	    $disabled = $this->getInfo('disabled') ? ' disabled="true"' : '';
	    $class = $this->getInfo('class') ? ' class="' . $this->getInfo('class') . '"' : '';
	    $required = $this->getInfo('required') ? ' required="true"' : '';
	    
		return "<input{$id}{$type}{$name}{$value}{$disabled}{$class}{$required} />";
	}
	
	public function setInfo($info)
	{
		$this->info = $info;
	}
	
	public function getInfo($key = null)
	{
		return $key ? (isset($this->info[$key]) ? $this->info[$key] : '') : $this->info;
	}
}