<?php

/**
 * class control all things related to plugin settings
 * @author grojanteam
 *
 */
class GJMAA_Controller_Categorymap extends GJMAA_Controller
{

    protected $content;

    protected $buttons = [
        'Add' => '&action=add'
    ];

    protected $parent = 'gjmaa_dashboard';

    public function getName()
    {
        $action = $this->getParam('action');

        switch ($action) {
            default:
                return 'Map category';
            case 'edit':
                return 'Edit map';
            case 'add':
                return 'Add map';
        }
    }
    
    public function addSubmenu(){
        return false;
    }

    public function renderView()
    {
        $html = '<div class="wrap">' . $this->getTitle() . $this->getContent() . '</div>';

        echo $html;
    }

    public function getMenuName()
    {
        return __('Map category', GJMAA_TEXT_DOMAIN);
    }

    /**
     * display table for settings
     */
    public function getContent()
    {
        return $this->content;
    }

    public function setContent($content)
    {
        $this->content = $content;
    }

    public function index()
    {
        $table = GJMAA::getTable('categorymap');
        $this->setContent($table->show());
    }

    public function add()
    {
        $this->buttons = [];
        $this->edit(0);
    }

    public function edit($id = null)
    {
        $this->buttons = [];
        $form = GJMAA::getForm('categorymap');
        $form->prepareForm();
        
        if($id) {
            $categoryMapModel = GJMAA::getModel('allegro_category_map');
            $categoryMapModel->load($id);
            
            $form->setValues($categoryMapModel->getData());
        }
        $form->generate();
        $this->setContent($form->toHtml());
    }

    public function save()
    {
        $params = $this->getParams();
        if (empty($params)) {
            $this->redirect($this->getIndexUrl());
            return;
        }
        
        try {
            $model = GJMAA::getModel('allegro_category_map');
            $model->setData($params);
            $model->save();

            $this->addSessionSuccess('Plugin setting saved successfully.');
        } catch (Exception $e) {
            $this->addSessionError($e->getMessage());
        }

        $this->redirect($this->getIndexUrl());
    }

    public function delete()
    {
        $map_id = $this->getParam('map_id');
        if (! $map_id) {
            $this->redirect($this->getIndexUrl());
            return;
        }

        try {
            $model = GJMAA::getModel('allegro_category_map');
            $model->load($map_id);
            $model->delete();

            $this->addSessionSuccess('Plugin setting removed successfully.');
        } catch (Exception $e) {
            $this->addSessionError($e->getMessage());
        }

        $this->redirect($this->getIndexUrl());
    }

    public function getSlug()
    {
        return 'gjmaa_categorymap';
    }
}

?>