<?php

class GJMAA_Cron_Import_Auctions
{

    public function execute()
    {
        $profiles = GJMAA::getModel('profiles');
        $allprofiles = $profiles->getAll();

        if (empty($allprofiles)) {
            return;
        }

        $helperImport = GJMAA::getHelper('import');

        $i = 0;
        foreach ($allprofiles as $profile) {
            if($profile['profile_errors'] > 5){
                continue;
            }
            do {
                try {
                    $profileId = $profile['profile_id'];
                    $response = $helperImport->runImportByProfileId($profileId, 'cron');
                    if ((isset($response['progress_step']) && $response['progress_step'] == 100) || $response['all_auctions'] == 0) {
                        break;
                    }
                } catch (Exception $e) {
                    error_log($e->getMessage());
                    break;
                }
                $i ++;
                sleep(1);
            } while ($i < 150);
        }
    }

    public static function run()
    {
        (new self())->execute();
    }
}
?>