<?php

class GJMAA_Cron_Woocommerce_Status
{

    public function execute()
    {
        $wooCommerceService = GJMAA::getService('woocommerce');
        if (! $wooCommerceService->isEnabled()) {
            return;
        }

        $profileModel = GJMAA::getModel('profiles');
        $wooCommerceProfileIds = $profileModel->getWooCommerceProfileIds();

        if (empty($wooCommerceProfileIds)) {
            return;
        }

        $filters = [
            'WHERE' => sprintf('auction_profile_id IN (%s)', implode(',', $wooCommerceProfileIds))
        ];

        $auctionsModel = GJMAA::getModel('auctions');
        $auctions = $auctionsModel->getAllBySearch($filters);

        if (empty($auctions)) {
            return;
        }

        foreach ($auctions as $auction) {
            $auctionsModel->unsetData();
            $sku = $auction['auction_id'];
            $productId = wc_get_product_id_by_sku($sku);
            if (0 === $productId && ! $auction['auction_in_woocommerce']) {
                continue;
            }

            if (0 !== $productId && $auction['auction_in_woocommerce'] == 1) {
                continue;
            }

            $auction['auction_in_woocommerce'] = 0 !== $productId ? 1 : 0;
            $auctionsModel->setData($auction);
            $auctionsModel->save();
        }
    }

    public static function run()
    {
        (new self())->execute();
    }
}
?>