<?php

class GJMAA_Cron_Woocommerce_Stock
{

    public function execute()
    {
        $wooCommerceService = GJMAA::getService('woocommerce');
        if (! $wooCommerceService->isEnabled()) {
            return;
        }

        $profileModel = GJMAA::getModel('profiles');
        $wooCommerceProfileIds = $profileModel->getWooCommerceProfileIds();

        if (empty($wooCommerceProfileIds)) {
            return;
        }

        $filters = [
            'WHERE' => sprintf('auction_profile_id IN (%s)', implode(',', $wooCommerceProfileIds))
        ];

        $auctionsModel = GJMAA::getModel('auctions');
        $auctions = $auctionsModel->getAllBySearch($filters);

        if (empty($auctions)) {
            return;
        }

        $stockUpdateData = [];

        foreach ($auctions as $auction) {
            $isOutOfStock = ! is_null($auction['auction_time']) && strtotime($auction['auction_time']) < time();
            $stockUpdateData[$auction['auction_id']] = $auction['auction_quantity'] > 0 && ! $isOutOfStock ? $auction['auction_quantity'] : 0;
        }

        $wooCommerceService->updateStock($stockUpdateData);
    }

    public static function run()
    {
        (new self())->execute();
    }
}
?>