<?php

class GJMAA_Helper_Profiles
{

    public function getFieldsData($type = 'form')
    {
        return [
            'profile_id' => [
                'type' => 'hidden',
                'name' => 'profile_id'
            ],
            'profile_setting_id' => [
                'id' => 'setting_id',
                'type' => 'select',
                'name' => 'profile_setting_id',
                'label' => 'API Settings',
                'source' => 'settings',
                'required' => true,
                'help' => __('Choose API settings that you will used to import',GJMAA_TEXT_DOMAIN)
            ],
            'profile_name' => [
                'type' => 'text',
                'name' => 'profile_name',
                'label' => 'Name',
                'required' => true,
                'help' => __('Type here your custom profile name',GJMAA_TEXT_DOMAIN)
            ],
            'profile_type' => [
                'id' => 'profile_type',
                'type' => 'select',
                'name' => 'profile_type',
                'label' => 'Type of auctions',
                'source' => 'allegro_type',
                'required' => true,
                'help' => __('Choose type of auction that will be imported',GJMAA_TEXT_DOMAIN)
            ],
            'profile_auctions' => [
                'type' => 'number',
                'name' => 'profile_auctions',
                'label' => 'Count of auctions',
                'required' => true,
                'help' => __('Type number of auctions',GJMAA_TEXT_DOMAIN)
            ],
            'profile_category' => [
                'id' => 'category',
                'type' => 'select',
                'name' => 'profile_category',
                'label' => 'Category',
                'source' => $this->getSourceByType($type),
                'help' => __('Choose allegro category that will be filtered during import',GJMAA_TEXT_DOMAIN)
            ],
            'profile_category_hidden' => [
                'id' => 'category_hidden',
                'type' => 'hidden',
                'name' => 'profile_category_hidden'
            ],
            'profile_sort' => [
                'type' => 'select',
                'name' => 'profile_sort',
                'label' => 'Sort',
                'source' => 'allegro_sort',
                'help' => __('Choose type of sorting that will be imported',GJMAA_TEXT_DOMAIN)
            ],
            'profile_user' => [
                'id' => 'profile_user',
                'type' => 'text',
                'name' => 'profile_user',
                'label' => 'User',
                'help' => __('Type here allegro login of user that you want to import (ex. grojanteam)',GJMAA_TEXT_DOMAIN),
                'disabled' => true
            ],
            'profile_search_query' => [
                'id' => 'profile_search_query',
                'type' => 'text',
                'name' => 'profile_search_query',
                'label' => 'Query',
                'disabled' => true,
                'help' => __('Type here query that you want to find',GJMAA_TEXT_DOMAIN)
            ],
            'profile_last_sync' => [
                'type' => 'text',
                'name' => 'profile_last_sync',
                'label' => 'Last synchronization',
                'disabled' => true,
                'help' => __('Time of last synchronization',GJMAA_TEXT_DOMAIN)
            ],
            'profile_to_woocommerce' => [
                'type' => 'select',
                'name' => 'profile_to_woocommerce',
                'label' => 'WooCommerce?',
                'source' => 'yesno',
                'help' => __('Choose that you want import auctions from allegro to WooCommerce',GJMAA_TEXT_DOMAIN),
                'disabled' => !GJMAA::getService('woocommerce')->isEnabled()
            ],
            'save' => [
                'type' => 'submit',
                'name' => 'save',
                'label' => 'Save'
            ]
        ];
    }

    public function getTotalProfiles()
    {
        return GJMAA::getModel('profiles')->getCountAll();
    }
    
    public function getSourceByType($type)
    {
        switch ($type) {
            case 'table':
                return 'allegro_category_tree';
            default:
                return 'allegro_category';
        }
    }
}
?>