<?php

class GJMAA_Model_Categorymap extends GJMAA_Model
{

    protected $tableName = 'gjmaa_mapcategory_settings';

    protected $defaultPK = 'map_id';
    
    protected $oldTable = 'gj_map_category_settings';
    
    protected $map = [
        'map_id' => 'map_id',
        'allegro_category_id' => 'allegro_category_id',
        'woocommerce_category_id' => 'woocommerce_category_id'        
    ];

    protected $columns = [
        'map_id' => [
            'schema' => [
                'INT',
                'AUTO_INCREMENT',
                'NOT NULL'
            ],
            'format' => '%d'
        ],
        'allegro_category_id' => [
            'schema' => [
                'VARCHAR (255)',
                'NOT NULL'
            ],
            'format' => '%s'
        ],
        'woocommerce_category_id' => [
            'schema' => [
                'VARCHAR (255)',
                'NOT NULL'
            ],
            'format' => '%s'
        ]
    ];

    public function update($currentVersion)
    {
        if(version_compare($currentVersion,'2.0.0') < 0){
            $this->migerateFromOldToNew();
        }
        
        return $this;
    }
    
    public function migerateFromOldToNew()
    {
        $this->install();
        $mainTable = $this->tableName;
        $this->tableName = $this->oldTable;
        $mapCategories = $this->getAll();
        $this->tableName = $mainTable;
        
        foreach($mapCategories as $category){
            $result = [];
            foreach($this->map as $oldColumnName => $newColumnName){
                $result[$newColumnName] = $category[$oldColumnName];
            }
            
            $this->unsetData();
            $this->setData($result);
            $this->save();
        }
    }
    
    public function getMappedWooCommerceCategoriesByCategoryIds($productIds = null) {
        $query = 'SELECT woocommerce_category_id FROM ' . $this->getTable();
        if (is_array ( $productIds )) {
            $query .= " WHERE allegro_category_id IN (" . implode ( ',', $productIds ) . ")";
        } else {
            $query .= " WHERE allegro_category_id = $productIds";
        }
        
        return $this->wpdb->get_results ( $query, ARRAY_A );
    }
}